-- Drop all unused tables and views
0,DROP TABLE MGLINKSYSTSYST;
0,DROP TABLE MGLINKSYSTSECTION;
0,DROP TABLE MGLINKSYSTMOD;
0,DROP TABLE MGLINKSYSTTABLE;
0,DROP TABLE MGLINKSYSTCOL;
0,DROP TABLE MGLINKSYSTQUEST;

0,DROP VIEW SYSTAPPQUEST;
0,DROP VIEW SYSTAPPQUEST_V;
0,DROP VIEW APPQUEST_V;
0,DROP VIEW SYSTAPPQUESTTXT_V;
0,DROP VIEW SYSTINDEX_V;
0,DROP VIEW SYSTTABLE_V;
0,DROP VIEW SYSTCOL_V;

--Change size of field name to 30 car. in several tables
2,ALTER TABLE SYSTQUEST DROP PRIMARY KEY;
2,DROP INDEX I_SYSTQUEST;
2,DROP INDEX I_SYSTQUEST2;
2,ALTER TABLE SYSTQUEST MODIFY QUNAME CHAR(30) NOT NULL;
2,ALTER TABLE SYSTQUEST ADD PRIMARY KEY(APPSYSTNAME,SECTFULLPATH,QUNAME);
2,CREATE  UNIQUE INDEX I_SYSTQUEST  ON SYSTQUEST (APPSYSTNAME,SECTFULLPATH,QUNAME);
2,CREATE  UNIQUE INDEX I_SYSTQUEST2 ON SYSTQUEST (APPSYSTNAME,QUNAME);

2,ALTER TABLE SYSTQUESTTXT DROP PRIMARY KEY;
2,DROP INDEX I_SYSTQUESTTXT;
2,DROP INDEX I_SYSTQUESTTXT2;
2,ALTER TABLE SYSTQUESTTXT MODIFY QUNAME CHAR(30) NOT NULL;
2,ALTER TABLE SYSTQUESTTXT ADD PRIMARY KEY(APPSYSTNAME,SECTFULLPATH,QUNAME,LANGUE);
2,CREATE  UNIQUE INDEX I_SYSTQUESTTXT  ON SYSTQUESTTXT (APPSYSTNAME,SECTFULLPATH,QUNAME,LANGUE);
2,CREATE  UNIQUE INDEX I_SYSTQUESTTXT2 ON SYSTQUESTTXT (APPSYSTNAME,QUNAME,LANGUE);

2,ALTER TABLE APPMACROQUEST DROP PRIMARY KEY;
2,DROP INDEX I_APPMACROQUEST;
2,DROP INDEX I_APPMACROQUEST2;
2,ALTER TABLE APPMACROQUEST MODIFY QUNAME CHAR(30) NOT NULL;
2,ALTER TABLE APPMACROQUEST ADD PRIMARY KEY(APPSYSTNAME,SECTFULLPATH,APPNAME,LANGUE,MACROUNIQUENAME,QUNAME);
2,CREATE UNIQUE INDEX I_APPMACROQUEST  ON APPMACROQUEST(APPSYSTNAME,
                                                        SECTFULLPATH,
                                                        APPNAME,
                                                        LANGUE,
                                                        MACROUNIQUENAME,
                                                        QUNAME);
2,CREATE UNIQUE INDEX I_APPMACROQUEST2 ON APPMACROQUEST(APPSYSTNAME,
                                                        APPNAME,
                                                        LANGUE,
                                                        MACROUNIQUENAME,
                                                        QUNAME);

2,ALTER TABLE APPQUEST DROP PRIMARY KEY;
2,DROP INDEX I_APPQUEST;
2,DROP INDEX I_APPQUEST2;
2,ALTER TABLE APPQUEST MODIFY QUNAME CHAR(30) NOT NULL;
2,ALTER TABLE APPQUEST ADD PRIMARY KEY(APPSYSTNAME,SECTFULLPATH,MODNAME,GRPNAME,QUNAME);
2,CREATE  UNIQUE INDEX I_APPQUEST  ON APPQUEST(APPSYSTNAME,SECTFULLPATH,MODNAME,GRPNAME,QUNAME);
2,CREATE  UNIQUE INDEX I_APPQUEST2 ON APPQUEST(APPSYSTNAME,MODNAME,GRPNAME,QUNAME);

2,ALTER TABLE APPQUESTTXT DROP PRIMARY KEY;
2,DROP INDEX I_APPQUESTTXT;
2,DROP INDEX I_APPQUESTTXT2;
2,ALTER TABLE APPQUESTTXT MODIFY QUNAME CHAR(30) NOT NULL;
2,ALTER TABLE APPQUESTTXT ADD PRIMARY KEY(APPSYSTNAME,SECTFULLPATH,MODNAME,GRPNAME,QUNAME,LANGUE);
2,CREATE  UNIQUE INDEX I_APPQUESTTXT  ON APPQUESTTXT(APPSYSTNAME,
                                                     SECTFULLPATH,
                                                     MODNAME,
                                                     GRPNAME,
                                                     QUNAME,
                                                     LANGUE);
2,CREATE  UNIQUE INDEX I_APPQUESTTXT2 ON APPQUESTTXT(APPSYSTNAME,
                                                     MODNAME,
                                                     GRPNAME,
                                                     QUNAME,
                                                     LANGUE);

2,ALTER TABLE APPCTL MODIFY QUNAME CHAR(30);

2,ALTER TABLE APPIMPANS DROP PRIMARY KEY;
2,DROP INDEX I_APPIMPANS;
2,DROP INDEX I_APPIMPANS2;
2,ALTER TABLE APPIMPANS MODIFY QUNAME CHAR(30) NOT NULL;
2,ALTER TABLE APPIMPANS MODIFY ANSQUNAME CHAR(30);
2,ALTER TABLE APPIMPANS ADD PRIMARY KEY(APPSYSTNAME,SECTFULLPATH,APPNAME,LANGUE,RIACCESS,RIRELNAME,GRPNAME,QUNAME);
2,CREATE  UNIQUE INDEX I_APPIMPANS  ON APPIMPANS(APPSYSTNAME,
                                                 SECTFULLPATH,
                                                 APPNAME,
                                                 LANGUE,
                                                 RIACCESS,
                                                 RIRELNAME,
                                                 GRPNAME,
                                                 QUNAME);
2,CREATE  UNIQUE INDEX I_APPIMPANS2 ON APPIMPANS(APPSYSTNAME,
                                                 APPNAME,
                                                 LANGUE,
                                                 RIACCESS,
                                                 RIRELNAME,
                                                 GRPNAME,
                                                 QUNAME);

2,ALTER TABLE APPPRTDEF DROP PRIMARY KEY;
2,DROP INDEX I_APPPRTDEF;
2,DROP INDEX I_APPPRTDEF2;
2,ALTER TABLE APPPRTDEF MODIFY QUNAME CHAR(30) NOT NULL;
2,ALTER TABLE APPPRTDEF ADD PRIMARY KEY(APPSYSTNAME,SECTFULLPATH,APPNAME,PRTACCESS,PRTRELNAME,GRPNAME,QUNAME);
2,CREATE  UNIQUE INDEX I_APPPRTDEF  ON APPPRTDEF(APPSYSTNAME,
                                                 SECTFULLPATH,
                                                 APPNAME,
                                                 PRTACCESS,
                                                 PRTRELNAME,
                                                 GRPNAME,
                                                 QUNAME);
2,CREATE  UNIQUE INDEX I_APPPRTDEF2 ON APPPRTDEF(APPSYSTNAME,
                                                 APPNAME,
                                                 PRTACCESS,
                                                 PRTRELNAME,
                                                 GRPNAME,
                                                 QUNAME);

-- Add user context to PROTASSIGN table
2,ALTER TABLE PROTASSIGN DROP PRIMARY KEY;
2,DROP INDEX I_PROTASSIGN;
2,ALTER TABLE PROTASSIGN ADD USERCONTEXT CHAR(255);
2,UPDATE PROTASSIGN SET USERCONTEXT='$DEFAULT';
2,ALTER TABLE PROTASSIGN MODIFY USERCONTEXT CHAR(255) NOT NULL;
2,ALTER TABLE PROTASSIGN ADD PRIMARY KEY(ENTRYSYSTID,
                                         ENTRYID,
                                         ASSIGNPRGTYPE,
                                         SYSTID,
                                         PRGID,
										 USERCONTEXT,
                                         ASSIGNUSRTYPE,
                                         USRID,
                                         COMPID,
                                         STATIONID,
                                         DATESTART,
                                         DATEEND,
                                         TIMESTART,
                                         TIMEEND,
                                         WEEKDAYSTART,
                                         WEEKDAYEND);
2,CREATE  UNIQUE INDEX I_PROTASSIGN ON PROTASSIGN(ENTRYSYSTID,
                                                  ENTRYID,
                                                  ASSIGNPRGTYPE,
                                                  SYSTID,
                                                  PRGID,
												  USERCONTEXT,
                                                  ASSIGNUSRTYPE,
                                                  USRID,
                                                  COMPID,
                                                  STATIONID,
                                                  DATESTART,
                                                  DATEEND,
                                                  TIMESTART,
                                                  TIMEEND,
                                                  WEEKDAYSTART,
                                                  WEEKDAYEND);

-- Modify SYSTAPP for new definable selection box fields' group
2,ALTER TABLE SYSTAPP ADD APPDEFLST VARCHAR(16);
2,UPDATE SYSTAPP SET APPDEFLST = '$LST';

-- Modify SYSTACTION : action ID is no longer required
2,ALTER TABLE SYSTACTION MODIFY ACTIONID NULL;
2,DROP INDEX I_SYSTACTION3;

-- Add new colums to several tables
2,ALTER TABLE SYSTTABLECOL  ADD COLPHYSNAME     VARCHAR(240)  NULL;
2,ALTER TABLE SYSTQUESTTXT  ADD ANSDEFAULT      VARCHAR(240)  NULL;
2,ALTER TABLE APPQUESTTXT   ADD ANSDEFAULT      VARCHAR(240)  NULL;
2,ALTER TABLE APPSTR        ADD STRNAMECASE     CHAR(64);
2,ALTER TABLE APPQUESTTXT   ADD QUHELP          LONG VARCHAR;
2,ALTER TABLE SYSTAPP       ADD APPNOTES        LONG VARCHAR;
2,ALTER TABLE SYSTMITEM     ADD MITEMNOTES      LONG VARCHAR;
2,ALTER TABLE SYSTMENULIST  ADD MENUNOTES       LONG VARCHAR;
2,ALTER TABLE SYSTQUEST     ADD QUNOTES         LONG VARCHAR;
2,ALTER TABLE PROTENTRY     ADD ENTRYNOTES      LONG VARCHAR;
2,ALTER TABLE SYSTACTIONTXT ADD BUTTONTEXT      VARCHAR(80);
2,ALTER TABLE APPCTL        ADD CTLINDEX        DECIMAL(5);
2,ALTER TABLE APPCTL        ADD CTLNAME         CHAR(30);
2,ALTER TABLE PROTASSIGN    ADD ASSIGNENTRYTYPE DECIMAL(1);
2,ALTER TABLE PROTUSR       ADD EMAIL           VARCHAR(240);
-- Add UDA                                      
2,ALTER TABLE SYSTQUEST     ADD ATTRSVAL        VARCHAR(4000) NULL;
2,ALTER TABLE APPQUEST      ADD ATTRSVAL        VARCHAR(4000) NULL;
2,ALTER TABLE PROTUSR       ADD ATTRSVAL        VARCHAR(4000) NULL;
2,ALTER TABLE SYSTMODULE    ADD ATTRSVAL        VARCHAR(4000) NULL;
2,ALTER TABLE PROTCOMP      ADD ATTRSVAL        VARCHAR(4000) NULL;
-- Modify existing column
2,ALTER TABLE APPCTL        MODIFY CTLCLASSNAME CHAR(48);
2,ALTER TABLE SYSTQUEST     MODIFY QUATTR                      NULL;
2,ALTER TABLE SYSTQUEST     MODIFY ANSATTR                     NULL;
2,ALTER TABLE SYSTQUEST     MODIFY ANSMINCHR    DECIMAL(5) NOT NULL;
2,ALTER TABLE SYSTQUEST     MODIFY ANSMAXCHR    DECIMAL(5) NOT NULL;
2,ALTER TABLE SYSTQUEST     MODIFY INPMASK      VARCHAR(240)   NULL;
2,ALTER TABLE APPQUEST      MODIFY INPMASK      VARCHAR(240)   NULL;
2,ALTER TABLE SYSTMENULIST  MODIFY PROTECPRGID  CHAR(16);
2,ALTER TABLE APPBLOB       MODIFY BLOBDESC     LONG VARCHAR;

-- Create tables for VCS
2,CREATE TABLE VCSHISTORY(
    APPSYSTNAME                     VARCHAR(16) NOT NULL,
    SECTFULLPATH                    VARCHAR(80) NOT NULL,
    COMPNAME                        VARCHAR(30) NOT NULL,
    COMPTYPE                        DECIMAL(3) NOT NULL,
    USRID                           VARCHAR(16) NOT NULL,
    HISTORYDATE                     TIMESTAMP NOT NULL,
    ACTIONCODE                      DECIMAL(3) NOT NULL,
    VERSION                         DECIMAL(6) NOT NULL,
    HISTORYDESC                     VARCHAR(4096),
    PRIMARY KEY (APPSYSTNAME,SECTFULLPATH,COMPNAME,COMPTYPE,HISTORYDATE,ACTIONCODE) );
0,DROP INDEX SD_PRIMARY_VCSHISTORY;
2,CREATE UNIQUE INDEX SD_PRIMARY_VCSHISTORY ON VCSHISTORY(
                                    APPSYSTNAME,
                                    SECTFULLPATH,
                                    COMPNAME,
                                    COMPTYPE,
                                    HISTORYDATE,
                                    ACTIONCODE );

2,CREATE TABLE VCSCKTRANSLOG(
    APPSYSTNAME                     VARCHAR(16) NOT NULL,
    SECTFULLPATH                    VARCHAR(80) NOT NULL,
    COMPNAME                        VARCHAR(30) NOT NULL,
    COMPTYPE                        DECIMAL(3) NOT NULL,
    USRID                           VARCHAR(16) NOT NULL,
    STRINGDATA1                     VARCHAR(80),
    NUMDATA1                        DECIMAL(3),
    SUBCOMPINDEX                    DECIMAL(6) NOT NULL,
    STRINGDATA2                     VARCHAR(80),
    STRINGDATA3                     VARCHAR(80),
    NUMDATA2                        DECIMAL(3),
    MODCODE                         DECIMAL(3) NOT NULL,
    LONGDATA1                       VARCHAR(8192),
    PRIMARY KEY (APPSYSTNAME,SECTFULLPATH,COMPNAME,COMPTYPE,STRINGDATA1,NUMDATA1,SUBCOMPINDEX) );
0,DROP INDEX SD_PRIMARY_VCSCKTRANSLOG;
2,CREATE UNIQUE INDEX SD_PRIMARY_VCSCKTRANSLOG ON VCSCKTRANSLOG(
                                    APPSYSTNAME,
                                    SECTFULLPATH,
                                    COMPNAME,
                                    COMPTYPE,
									STRINGDATA1,
									NUMDATA1,
                                    SUBCOMPINDEX );

2,CREATE TABLE VCSCHECKOUTLST(
    APPSYSTNAME                     VARCHAR(16) NOT NULL,
    SECTFULLPATH                    VARCHAR(80) NOT NULL,
    COMPNAME                        VARCHAR(30) NOT NULL,
    COMPTYPE                        DECIMAL(3) NOT NULL,
    USRID                           VARCHAR(16) NOT NULL,
    CHECKOUTDATE                    TIMESTAMP NOT NULL,
    LASTMODIFDATE                   TIMESTAMP,
    CHECKOUTDESC                    VARCHAR(4096),
    PRIMARY KEY (APPSYSTNAME,SECTFULLPATH,COMPNAME,COMPTYPE) );
0,DROP INDEX SD_PRIMARY_VCSCHECKOUTLST;
2,CREATE UNIQUE INDEX SD_PRIMARY_VCSCHECKOUTLST ON VCSCHECKOUTLST(
                                    APPSYSTNAME,
                                    SECTFULLPATH,
                                    COMPNAME,
                                    COMPTYPE );
-- New tables for new tool format
2,CREATE  TABLE APPTOOLFORMAT (
    APPSYSTNAME     CHAR    (16)  NOT NULL,
    SECTFULLPATH    CHAR    (80)  NOT NULL,
    APPNAME         CHAR    (16)  NOT NULL,
    LANGUE          DECIMAL (3)   NOT NULL,
    TOOLACCESS      DECIMAL (3)   NOT NULL,
    TOOLRELNAME     CHAR    (32)  NOT NULL,
    TOOLCAT         DECIMAL (3)   NOT NULL,
    TOOLTYPE        DECIMAL (3)   NOT NULL,
    TOOLTAG         CHAR    (64)  NOT NULL,
    TOOLVALID       VARBINARY(128) NOT NULL,
    PRIMARY KEY (APPSYSTNAME,SECTFULLPATH,APPNAME,LANGUE,TOOLACCESS,TOOLRELNAME,TOOLCAT,TOOLTYPE,TOOLTAG));
2,CREATE UNIQUE INDEX I_APPTOOLFORMAT1 ON APPTOOLFORMAT(APPSYSTNAME,SECTFULLPATH,APPNAME,LANGUE,
TOOLACCESS,TOOLRELNAME,TOOLCAT,TOOLTYPE,TOOLTAG);
2,CREATE UNIQUE INDEX I_APPTOOLFORMAT2 ON APPTOOLFORMAT(APPSYSTNAME,APPNAME,LANGUE,
TOOLACCESS,TOOLRELNAME,TOOLCAT,TOOLTYPE,TOOLTAG);
2,CREATE TABLE APPTOOLFORMATDATA ( 
    APPSYSTNAME     CHAR    (16)  NOT NULL,
    SECTFULLPATH    CHAR    (80)  NOT NULL,
    APPNAME         CHAR    (16)  NOT NULL,
    LANGUE          DECIMAL (3)   NOT NULL,
    TOOLACCESS      DECIMAL (3)   NOT NULL,
    TOOLRELNAME     CHAR    (32)  NOT NULL,
    TOOLCAT         DECIMAL (3)   NOT NULL,
    TOOLTYPE        DECIMAL (3)   NOT NULL,
    TOOLTAG         CHAR    (64)  NOT NULL,
    TOOLSEQ         DECIMAL (3)   NOT NULL,
    TOOLDATA        LONG BINARY,
    PRIMARY KEY (APPSYSTNAME,SECTFULLPATH,APPNAME,LANGUE,TOOLACCESS,TOOLRELNAME,TOOLCAT,TOOLTYPE,TOOLTAG,TOOLSEQ));
2,CREATE UNIQUE INDEX I_APPTOOLFRMTDATA1 ON APPTOOLFORMATDATA(APPSYSTNAME,SECTFULLPATH,APPNAME,LANGUE,
TOOLACCESS,TOOLRELNAME,TOOLCAT,TOOLTYPE,TOOLTAG,TOOLSEQ);
2,CREATE UNIQUE INDEX I_APPTOOLFRMTDATA2 ON APPTOOLFORMATDATA(APPSYSTNAME,APPNAME,LANGUE,
TOOLACCESS,TOOLRELNAME,TOOLCAT,TOOLTYPE,TOOLTAG,TOOLSEQ);

-- New tables for persistence
2,CREATE  TABLE FORMPERSIST (
    APPSYSTNAME     CHAR    (16)  NOT NULL,
    SECTFULLPATH    CHAR    (80)  NOT NULL,
    MODNAME         CHAR    (16)  NOT NULL,
	GRPNAME         CHAR    (16)  NOT NULL,
    LANGUE          DECIMAL (3)   NOT NULL,
    PERSCAT         DECIMAL (3)   NOT NULL,
    PERSTYPE        DECIMAL (3)   NOT NULL,
    PERSTAG         CHAR    (64)  NOT NULL,
    PERSVALID       VARBINARY(128)  NOT NULL,
    PRIMARY KEY (APPSYSTNAME,SECTFULLPATH,MODNAME,GRPNAME,LANGUE,PERSCAT,PERSTYPE,PERSTAG));
2,CREATE UNIQUE INDEX I_FORMPERSIST1 ON FORMPERSIST(APPSYSTNAME,SECTFULLPATH,MODNAME,GRPNAME,LANGUE,
PERSCAT,PERSTYPE,PERSTAG);
2,CREATE UNIQUE INDEX I_FORMPERSIST2 ON FORMPERSIST(APPSYSTNAME,MODNAME,GRPNAME,LANGUE,
PERSCAT,PERSTYPE,PERSTAG);
2,CREATE TABLE FORMPERSISTDATA ( 
    APPSYSTNAME     CHAR    (16)  NOT NULL,
    SECTFULLPATH    CHAR    (80)  NOT NULL,
    MODNAME         CHAR    (16)  NOT NULL,
	GRPNAME         CHAR    (16)  NOT NULL,
    LANGUE          DECIMAL (3)   NOT NULL,
    PERSCAT         DECIMAL (3)   NOT NULL,
    PERSTYPE        DECIMAL (3)   NOT NULL,
    PERSTAG         CHAR    (64)  NOT NULL,
    PERSSEQ         DECIMAL (3)   NOT NULL,
    PERSDATA        LONG BINARY,
    PRIMARY KEY (APPSYSTNAME,SECTFULLPATH,MODNAME,GRPNAME,LANGUE,PERSCAT,PERSTYPE,PERSTAG,PERSSEQ));
2,CREATE UNIQUE INDEX I_FORMPERSISTDATA1 ON FORMPERSISTDATA(APPSYSTNAME,SECTFULLPATH,MODNAME,GRPNAME,LANGUE,
PERSCAT,PERSTYPE,PERSTAG,PERSSEQ);
2,CREATE UNIQUE INDEX I_FORMPERSISTDATA2 ON FORMPERSISTDATA(APPSYSTNAME,MODNAME,GRPNAME,LANGUE,
PERSCAT,PERSTYPE,PERSTAG,PERSSEQ);

-- New table for Type Library
0,DROP TABLE MODTYPELIB;
2,CREATE TABLE MODTYPELIB ( 
    APPSYSTNAME     CHAR    (16)    NOT NULL,
    SECTFULLPATH    CHAR    (80)    NOT NULL,
    MODNAME         CHAR    (16)    NOT NULL,
    GUID            CHAR    (48)    NOT NULL, 
    TYPELIBNAME     CHAR    (64)    NOT NULL,
    TYPELIB         DECIMAL (3)     NOT NULL,
    MAJVERSION	    DECIMAL(3),
    MINVERSION	    DECIMAL(3),
	LCID            DECIMAL(9),
    PRIMARY KEY (APPSYSTNAME,SECTFULLPATH,MODNAME,GUID));
2,CREATE UNIQUE INDEX I_MODTYPELIB1 ON MODTYPELIB(APPSYSTNAME,SECTFULLPATH,MODNAME,GUID);

-- New tables for CARDS
2,CREATE TABLE MODCARD(
    APPSYSTNAME         CHAR(16) NOT NULL,
    SECTFULLPATH        CHAR(80) NOT NULL,
    MODNAME             CHAR(16) NOT NULL,
    CARDNAME            CHAR(16) NOT NULL,
    CARDOPT             DECIMAL(3),
    ATTRSVAL            VARCHAR(4000),
    CARDDESC            VARCHAR(4096),
    PRIMARY KEY (APPSYSTNAME,SECTFULLPATH,MODNAME,CARDNAME));
2,CREATE UNIQUE INDEX SD_PRIMARY_MODCARD ON MODCARD(APPSYSTNAME,SECTFULLPATH,MODNAME,CARDNAME);
2,CREATE TABLE MODCARDGRP(
    APPSYSTNAME         CHAR(16) NOT NULL,
    SECTFULLPATH        CHAR(80) NOT NULL,
    MODNAME             CHAR(16) NOT NULL,
    CARDNAME            CHAR(16) NOT NULL,
    CARDGRPID           SMALLINT NOT NULL,
    GRPNAME             CHAR(16) NOT NULL,
    FATHERCARDGRPID     SMALLINT NOT NULL,
    GRPTYPE             DECIMAL(1) NOT NULL,
    GRPINSTOPT          DECIMAL(2) NOT NULL,
    DELAYREADING        DECIMAL(1) NOT NULL,
    SQLCACHEOPT         DECIMAL(1) NOT NULL,
    DATACACHESIZE       DECIMAL(10) NOT NULL,
    DELCACHESIZE        DECIMAL(10) NOT NULL,
    ISPKBROKEN          DECIMAL(1),
    AUTOINCMODE         DECIMAL(2),
    SEQNAME             VARCHAR(30),
    ATTRSVAL            VARCHAR(4000),
    PRIMARY KEY (APPSYSTNAME,SECTFULLPATH,MODNAME,CARDNAME,CARDGRPID));
2,CREATE UNIQUE INDEX SD_PRIMARY_MODCARDGRP ON MODCARDGRP(APPSYSTNAME,SECTFULLPATH,MODNAME,CARDNAME,CARDGRPID);

-- New tables for GROUPS
2,CREATE TABLE MODGRP (
    APPSYSTNAME     CHAR       (16)    NOT NULL,
    SECTFULLPATH    CHAR       (80)    NOT NULL,
    MODNAME         CHAR       (16)    NOT NULL,
    GRPNAME         CHAR       (16)    NOT NULL,
    TABLENAME       CHAR       (30)        NULL,
    ATTRSVAL        VARCHAR  (4000)        NULL,
    GRPDESC         LONG VARCHAR           NULL,
    PRIMARY KEY(APPSYSTNAME,SECTFULLPATH,MODNAME,GRPNAME));
2,CREATE UNIQUE INDEX I_MODGRP ON MODGRP(APPSYSTNAME,SECTFULLPATH,MODNAME,GRPNAME);
2,CREATE UNIQUE INDEX I_MODGRP2 ON MODGRP(APPSYSTNAME,MODNAME,GRPNAME);
2,CREATE TABLE MODGRPTXT (
    APPSYSTNAME     CHAR       (16)    NOT NULL,
    SECTFULLPATH    CHAR       (80)    NOT NULL,
    MODNAME         CHAR       (16)    NOT NULL,
    GRPNAME         CHAR       (16)    NOT NULL,
    LANGUE          DECIMAL     (3)    NOT NULL,
    GRPHELP         LONG VARCHAR           NULL,
    PRIMARY KEY(APPSYSTNAME,SECTFULLPATH,MODNAME,GRPNAME,LANGUE));
2,CREATE UNIQUE INDEX I_MODGRPTXT ON MODGRPTXT(APPSYSTNAME,SECTFULLPATH,MODNAME,GRPNAME,LANGUE);
2,CREATE UNIQUE INDEX I_MODGRPTXT2 ON MODGRPTXT(APPSYSTNAME,MODNAME,GRPNAME,LANGUE);

-- New tables for HTMLFILES
2,CREATE TABLE MODHTMLFILE(
    APPSYSTNAME     CHAR       (16)    NOT NULL,
    SECTFULLPATH    CHAR       (80)    NOT NULL,
    MODNAME         CHAR       (16)    NOT NULL,
    HTMLFILENAMEUC  VARCHAR    (255)   NOT NULL,
    HTMLFILENAME    VARCHAR    (255)   NOT NULL,
    HTMLOPT         DECIMAL    (10)    NOT NULL,
    ISMULTILANGUAGE SMALLINT           NOT NULL,
    ATTRSVAL        VARCHAR(4000)          NULL,
    HTMLFILEDESC    LONG VARCHAR           NULL,
    PRIMARY KEY(APPSYSTNAME,SECTFULLPATH,MODNAME,HTMLFILENAMEUC));
2,CREATE UNIQUE INDEX I_MODHTMLFILE ON MODHTMLFILE(APPSYSTNAME,SECTFULLPATH,MODNAME,HTMLFILENAMEUC);
2,CREATE UNIQUE INDEX I_MODHTMLFILE2 ON MODHTMLFILE(APPSYSTNAME,MODNAME,HTMLFILENAMEUC);
2,CREATE TABLE MODHTMLFILEASSIGN(
    APPSYSTNAME     CHAR       (16)    NOT NULL,
    SECTFULLPATH    CHAR       (80)    NOT NULL,
    MODNAME         CHAR       (16)    NOT NULL,
    HTMLFILENAMEUC  VARCHAR    (255)   NOT NULL,
    HTMLFORMNAME    VARCHAR    (255)   NOT NULL,
    HTMLCTLNAME     VARCHAR    (255)   NOT NULL,
    GRPNAME         CHAR       (16)    NOT NULL,
    FLDNAME         CHAR       (30)    NOT NULL,
    ASSIGNTYPE      SMALLINT           NOT NULL,
    PRIMARY KEY(APPSYSTNAME,SECTFULLPATH,MODNAME,HTMLFILENAMEUC,HTMLFORMNAME,HTMLCTLNAME));
2,CREATE UNIQUE INDEX I_MODHTMLFILEASSIGN ON MODHTMLFILEASSIGN(APPSYSTNAME,SECTFULLPATH,MODNAME,HTMLFILENAMEUC,HTMLFORMNAME,HTMLCTLNAME);
2,CREATE UNIQUE INDEX I_MODHTMLFILEASSIGN2 ON MODHTMLFILEASSIGN(APPSYSTNAME,MODNAME,HTMLFILENAMEUC,HTMLFORMNAME,HTMLCTLNAME);

-- New tables for user defined attributes
2,CREATE TABLE USRDEFATTRLST(
    ATTRLSTNAME     CHAR       (16) NOT NULL,
    CREATIONDATE    TIMESTAMP,
    LASTMODIFDATE   TIMESTAMP,
    ATTRLSTNOTES    VARCHAR  (8192),
    PRIMARY KEY(ATTRLSTNAME));
2,CREATE UNIQUE INDEX I_USRDEFATTRLST ON USRDEFATTRLST(ATTRLSTNAME);
2,CREATE TABLE USRDEFATTRLSTSYS(
    ATTRLSTNAME     CHAR       (16) NOT NULL,
    APPSYSTNAME     CHAR       (16) NOT NULL,
    SECTFULLPATH    CHAR       (80) NOT NULL,
    PRIMARY KEY(ATTRLSTNAME,APPSYSTNAME,SECTFULLPATH));
2,CREATE UNIQUE INDEX I_USRDEFATTRLSTSYS ON USRDEFATTRLSTSYS(ATTRLSTNAME,APPSYSTNAME,SECTFULLPATH);
2,CREATE TABLE USRDEFATTR(
    ATTRLSTNAME     CHAR       (16) NOT NULL,
    ATTRNAME        CHAR       (16) NOT NULL,
    ATTRPROMPT      VARCHAR    (80),
    ATTRCAT         DECIMAL     (2) NOT NULL,
    ATTRTYPE        DECIMAL     (3) NOT NULL,
    ANSDEFAULT      VARCHAR   (240),
    ANSCHOICE       VARCHAR   (240),
    CTLTYPE         DECIMAL     (3) NOT NULL,
    ATTRMAXSIZE     DECIMAL     (2) NOT NULL,
    ATTRFLAGS       DECIMAL     (3) NOT NULL,
    ATTRHELP        VARCHAR  (8192),
    PRIMARY KEY(ATTRLSTNAME,ATTRNAME,ATTRCAT));
2,CREATE UNIQUE INDEX I_USRDEFATTR ON USRDEFATTR(ATTRLSTNAME,ATTRNAME,ATTRCAT);
-- New tables for PROTEC
2,CREATE TABLE PROTFUNC (
    APPSYSTNAME     CHAR    (16) NOT NULL,
    FUNCID          CHAR    (16) NOT NULL,
    ENTRYSYSTID     CHAR    (16) NOT NULL,
    ENTRYID         CHAR    (16) NOT NULL,
    FUNCCAT         CHAR    (40),
    FUNCVALUE       CHAR    (128),
    FUNCNOTES       LONG VARCHAR,
    PRIMARY KEY(APPSYSTNAME,FUNCID));
2,CREATE  UNIQUE INDEX I_PROTFUNC ON PROTFUNC(APPSYSTNAME,FUNCID);

2,CREATE TABLE PROTFUNCTXT (
    APPSYSTNAME     CHAR    (16) NOT NULL,
    FUNCID          CHAR    (16) NOT NULL,
    LANGUE          DECIMAL (3)  NOT NULL,
    FUNCNAME        CHAR    (40) NOT NULL,
    FUNCHELP        LONG VARCHAR,
    PRIMARY KEY(APPSYSTNAME,FUNCID,LANGUE));
2,CREATE  UNIQUE INDEX I_PROTFUNCTXT ON PROTFUNCTXT(APPSYSTNAME,FUNCID,LANGUE);

2,CREATE TABLE PROTROLE (
    APPSYSTNAME     CHAR    (16) NOT NULL,
    ROLEID          CHAR    (16) NOT NULL,
    ROLECAT         CHAR    (40),
    CREATIONDATE    TIMESTAMP,
    LASTMODIFDATE   TIMESTAMP,
    ROLENOTES       LONG VARCHAR,
    PRIMARY KEY(APPSYSTNAME,ROLEID));
2,CREATE  UNIQUE INDEX I_PROTROLE ON PROTROLE(APPSYSTNAME,ROLEID);

2,CREATE TABLE PROTROLETXT (
    APPSYSTNAME     CHAR    (16) NOT NULL,
    ROLEID          CHAR    (16) NOT NULL,
    LANGUE          DECIMAL (3)  NOT NULL,
    ROLENAME        CHAR    (40) NOT NULL,
    ROLEHELP        LONG VARCHAR,
    PRIMARY KEY(APPSYSTNAME,ROLEID,LANGUE));
2,CREATE  UNIQUE INDEX I_PROTROLETXT ON PROTROLETXT(APPSYSTNAME,ROLEID,LANGUE);

2,CREATE TABLE PROTROLEFUNC (
    APPSYSTNAME     CHAR    (16) NOT NULL,
    ROLEID          CHAR    (16) NOT NULL,
    FUNCID          CHAR    (16) NOT NULL,
    PRIMARY KEY(APPSYSTNAME,ROLEID,FUNCID));
2,CREATE  UNIQUE INDEX I_PROTROLEFUNC ON PROTROLEFUNC(APPSYSTNAME,ROLEID,FUNCID);

-- Insert a new security entry to allow import
0,INSERT INTO PROTENTRY(ENTRYSYSTID,ENTRYID,FULLNAME,DATATYPE,CONFLICTRES,DEFAULTVAL,SUPERVAL,ENTRYNOTES)
   VALUES('$SYSTEM','$REP_IMPORT_SYS', 'Permission to import systems', 1, 1, 'F', 'T', NULL);
