0,DROP TABLE PROTFUNC;
0,DROP TABLE PROTFUNCTXT;
0,DROP TABLE PROTROLE;
0,DROP TABLE PROTROLETXT;
0,DROP TABLE PROTROLEFUNC;

2,CREATE TABLE PROTFUNC (
    APPSYSTNAME     VARCHAR (16)  NOT NULL,
    FUNCID          VARCHAR (16)  NOT NULL,
    ENTRYSYSTID     VARCHAR (16)  NOT NULL,
    ENTRYID         VARCHAR (16)  NOT NULL,
    FUNCCAT         VARCHAR (40),
    FUNCVALUE       VARCHAR (128) NOT NULL, 
    FUNCNOTES       LONG VARCHAR,
    PRIMARY KEY(APPSYSTNAME,FUNCID)
    ) ENABLE PRIMARY KEY USING INDEX;

2,CREATE TABLE PROTFUNCTXT (
    APPSYSTNAME     VARCHAR (16)  NOT NULL,
    FUNCID          VARCHAR (16)  NOT NULL,
    LANGUE          DECIMAL (3)   NOT NULL,
    FUNCNAME        VARCHAR (40)  NOT NULL,
    FUNCHELP        LONG VARCHAR,
    PRIMARY KEY(APPSYSTNAME,FUNCID,LANGUE)
    ) ENABLE PRIMARY KEY USING INDEX;

2,CREATE TABLE PROTROLE (
    APPSYSTNAME     VARCHAR (16)  NOT NULL,
    ROLEID          VARCHAR (16)  NOT NULL,
    ROLECAT         VARCHAR (40),
    CREATIONDATE    DATE,
    LASTMODIFDATE   DATE,
    ROLENOTES       LONG VARCHAR,
    PRIMARY KEY(APPSYSTNAME,ROLEID)
    ) ENABLE PRIMARY KEY USING INDEX;

2,CREATE TABLE PROTROLETXT (
    APPSYSTNAME     VARCHAR (16)  NOT NULL,
    ROLEID          VARCHAR (16)  NOT NULL,
    LANGUE          DECIMAL (3)   NOT NULL,
    ROLENAME        VARCHAR (40)  NOT NULL,
    ROLEHELP        LONG VARCHAR,
    PRIMARY KEY(APPSYSTNAME,ROLEID,LANGUE)
    ) ENABLE PRIMARY KEY USING INDEX;

2,CREATE TABLE PROTROLEFUNC (
    APPSYSTNAME     VARCHAR (16)  NOT NULL,
    ROLEID          VARCHAR (16)  NOT NULL,
    FUNCID          VARCHAR (16)  NOT NULL,
    PRIMARY KEY(APPSYSTNAME,ROLEID,FUNCID)
    ) ENABLE PRIMARY KEY USING INDEX;

2,ALTER TABLE PROTASSIGN ADD    ASSIGNENTRYTYPE DECIMAL  (1);
2,ALTER TABLE PROTUSR    ADD    EMAIL           VARCHAR2 (240);
2,ALTER TABLE APPBLOB    MODIFY BLOBDESC        LONG VARCHAR;
2,ALTER TABLE PROTASSIGN MODIFY USERCONTEXT VARCHAR (255);

2,ALTER TABLE USRDEFATTR DROP PRIMARY KEY;
2,ALTER TABLE USRDEFATTR ADD PRIMARY KEY (ATTRLSTNAME,ATTRNAME,ATTRCAT);
2,ALTER TABLE USRDEFATTR ENABLE PRIMARY KEY USING INDEX;