0,DROP TABLE PROTFUNC;
0,DROP TABLE PROTFUNCTXT;
0,DROP TABLE PROTROLE;
0,DROP TABLE PROTROLETXT;
0,DROP TABLE PROTROLEFUNC;

2,CREATE TABLE PROTFUNC (
    APPSYSTNAME     CHAR    (16) NOT NULL,
    FUNCID          CHAR    (16) NOT NULL,
    ENTRYSYSTID     CHAR    (16) NOT NULL,
    ENTRYID         CHAR    (16) NOT NULL,
    FUNCCAT         CHAR    (40),
    FUNCVALUE       CHAR    (128),
    FUNCNOTES       LONG VARCHAR,
    PRIMARY KEY(APPSYSTNAME,FUNCID));
2,CREATE  UNIQUE INDEX I_PROTFUNC ON PROTFUNC(APPSYSTNAME,FUNCID);

2,CREATE TABLE PROTFUNCTXT (
    APPSYSTNAME     CHAR    (16) NOT NULL,
    FUNCID          CHAR    (16) NOT NULL,
    LANGUE          DECIMAL (3)  NOT NULL,
    FUNCNAME        CHAR    (40) NOT NULL,
    FUNCHELP        LONG VARCHAR,
    PRIMARY KEY(APPSYSTNAME,FUNCID,LANGUE));
2,CREATE  UNIQUE INDEX I_PROTFUNCTXT ON PROTFUNCTXT(APPSYSTNAME,FUNCID,LANGUE);

2,CREATE TABLE PROTROLE (
    APPSYSTNAME     CHAR    (16) NOT NULL,
    ROLEID          CHAR    (16) NOT NULL,
    ROLECAT         CHAR    (40),
    CREATIONDATE    TIMESTAMP,
    LASTMODIFDATE   TIMESTAMP,
    ROLENOTES       LONG VARCHAR,
    PRIMARY KEY(APPSYSTNAME,ROLEID));
2,CREATE  UNIQUE INDEX I_PROTROLE ON PROTROLE(APPSYSTNAME,ROLEID);

2,CREATE TABLE PROTROLETXT (
    APPSYSTNAME     CHAR    (16) NOT NULL,
    ROLEID          CHAR    (16) NOT NULL,
    LANGUE          DECIMAL (3)  NOT NULL,
    ROLENAME        CHAR    (40) NOT NULL,
    ROLEHELP        LONG VARCHAR,
    PRIMARY KEY(APPSYSTNAME,ROLEID,LANGUE));
2,CREATE  UNIQUE INDEX I_PROTROLETXT ON PROTROLETXT(APPSYSTNAME,ROLEID,LANGUE);

2,CREATE TABLE PROTROLEFUNC (
    APPSYSTNAME     CHAR    (16) NOT NULL,
    ROLEID          CHAR    (16) NOT NULL,
    FUNCID          CHAR    (16) NOT NULL,
    PRIMARY KEY(APPSYSTNAME,ROLEID,FUNCID));
2,CREATE  UNIQUE INDEX I_PROTROLEFUNC ON PROTROLEFUNC(APPSYSTNAME,ROLEID,FUNCID);

2,ALTER TABLE PROTASSIGN ADD    ASSIGNENTRYTYPE DECIMAL  (1);
2,ALTER TABLE PROTUSR    ADD    EMAIL           VARCHAR  (240);
2,ALTER TABLE APPBLOB    MODIFY BLOBDESC        LONG VARCHAR;
-- change USERCONTEXT size from 48 to 255
2,ALTER TABLE PROTASSIGN DROP PRIMARY KEY;
2,DROP  INDEX I_PROTASSIGN;
2,ALTER TABLE PROTASSIGN MODIFY USERCONTEXT  CHAR (255) NOT NULL;
2,ALTER TABLE PROTASSIGN ADD PRIMARY KEY(ENTRYSYSTID, ENTRYID, ASSIGNPRGTYPE, SYSTID, PRGID,
                                         USERCONTEXT, ASSIGNUSRTYPE, USRID, COMPID, STATIONID,
                                         DATESTART, DATEEND, TIMESTART, TIMEEND,
                                         WEEKDAYSTART, WEEKDAYEND);
2,CREATE  UNIQUE INDEX I_PROTASSIGN ON PROTASSIGN(ENTRYSYSTID,
                                                  ENTRYID,
                                                  ASSIGNPRGTYPE,
                                                  SYSTID,
                                                  PRGID,
                                                  USERCONTEXT,
                                                  ASSIGNUSRTYPE,
                                                  USRID,
                                                  COMPID,
                                                  STATIONID,
                                                  DATESTART,
                                                  DATEEND,
                                                  TIMESTART,
                                                  TIMEEND,
                                                  WEEKDAYSTART,
                                                  WEEKDAYEND);

2,ALTER TABLE USRDEFATTR DROP PRIMARY KEY;
2,DROP INDEX I_USRDEFATTR;
2,ALTER TABLE USRDEFATTR ADD PRIMARY KEY(ATTRLSTNAME,ATTRNAME,ATTRCAT);
2,CREATE  UNIQUE INDEX I_USRDEFATTR  ON USRDEFATTR (ATTRLSTNAME,ATTRNAME,ATTRCAT);
