//
// Rep++ Framework for Windows Application
// Copyright (C) 2005 Consyst SQL Inc.
// All Rights Reserved
//
// This source code is only intended as a supplement to the
// Rep++ Studio products.
//
using System;
using System.Collections;
using System.Windows.Forms;
using RepPP;
using RepPP.Toolkit.Window;

namespace RepPP.Framework.Window {
    /// <summary>
    /// The ISBChildEditorFactory is an object factory producing object of type frmSBChildEditor
    /// </summary>
	public interface ISBChildEditorFactory {

        //******************************************************************
        //
	    /// <summary>
        /// CreateChildEditor           Creates a Selection Buffer Child Editor
        ///                             of the specified type
	    /// </summary>
	    /// <param name="iEditorType">  Type of the Editor</param>
	    /// <returns>
        /// A reference to the selection buffer child editor
        /// </returns>
        //
        //******************************************************************
        frmSBChildEditor CreateChildEditor(int iEditorType);
	}
}
