using System;
using RepPP.Toolkit;

namespace RepPP.Framework.Web {

    //********************************************************************************
    //
	/// <summary>
	/// IDataAcess:         Interface between the framework and the data access layer
	/// </summary>
    //
    //********************************************************************************
	public interface IDataAccess : IDisposable, ITransactionDataAccess, ISBDataAccess {

        //********************************************************************************
        //
	    /// <summary>
	    /// Initialize:                     Performs any required Initialization
	    /// </summary>
	    /// <param name="rowsetTree">            Card instance used to read the data</param>
	    //
        //********************************************************************************
        void Initialize(RowsetTree rowsetTree);
    }
}
