﻿using System;
using System.Reflection;

namespace RepPP.Toolkit.Designer {

    /// <summary>
    /// Utility Class used in designer
    /// </summary>
	public class DesignerUtil {

        //********************************************************************************
        //
        /// <summary>
        /// FindRepPPAssembly:          Find RepPP Assembly from an ToolKit Object
        /// </summary>
        /// <param name="objInTKNamespace">A neccessary Toolkit Object</param>
        /// <returns>
        /// Toolkit Assembly
        /// </returns>
        //
        //********************************************************************************
        public static Assembly FindRepPPAssembly(Object objInTKNamespace) {
            Assembly     assemTK;
            Assembly     assemRetVal;
            String       strAssemblyName;

            assemTK         = objInTKNamespace.GetType().Assembly;
            strAssemblyName = assemTK.GetName().Name;
            if (strAssemblyName != "RepPP.Toolkit.V1B") {
                throw new ArgumentException("Invalid Assembly passed to the function: " + strAssemblyName);
            }
            assemRetVal = assemTK.GetType("RepPP.Toolkit.ControlUtil").GetProperty("Application").PropertyType.Assembly;
            return(assemRetVal);
        }
	}
}
