0,DROP TABLE PROTFUNC;
0,DROP TABLE PROTFUNCTXT;
0,DROP TABLE PROTROLE;
0,DROP TABLE PROTROLETXT;
0,DROP TABLE PROTROLEFUNC;

2,CREATE TABLE PROTFUNC (
    APPSYSTNAME     varchar (16)  NOT NULL,
    FUNCID          varchar (16)  NOT NULL,
    ENTRYSYSTID     varchar (16)  NOT NULL,
    ENTRYID         varchar (16)  NOT NULL,
    FUNCCAT         varchar (40)  NULL,
    FUNCVALUE       varchar (128) NOT NULL, 
    FUNCNOTES       text          NULL);
2,CREATE  UNIQUE INDEX I_PROTFUNC ON PROTFUNC(APPSYSTNAME,FUNCID);

2,CREATE TABLE PROTFUNCTXT (
    APPSYSTNAME     varchar (16)  NOT NULL,
    FUNCID          varchar (16)  NOT NULL,
    LANGUE          smallint      NOT NULL,
    FUNCNAME        varchar (40)  NOT NULL,
    FUNCHELP        text          NULL);
2,CREATE  UNIQUE INDEX I_PROTFUNCTXT ON PROTFUNCTXT(APPSYSTNAME,FUNCID,LANGUE);

2,CREATE TABLE PROTROLE (
    APPSYSTNAME     varchar (16)  NOT NULL,
    ROLEID          varchar (16)  NOT NULL,
    ROLECAT         varchar (40)  NULL,
    CREATIONDATE    datetime      NULL,
    LASTMODIFDATE   datetime      NULL,
    ROLENOTES       text          NULL);
2,CREATE  UNIQUE INDEX I_PROTROLE ON PROTROLE(APPSYSTNAME,ROLEID);

2,CREATE TABLE PROTROLETXT (
    APPSYSTNAME     varchar (16)  NOT NULL,
    ROLEID          varchar (16)  NOT NULL,
    LANGUE          smallint      NOT NULL,
    ROLENAME        varchar (40)  NOT NULL,
    ROLEHELP        text          NULL);
2,CREATE  UNIQUE INDEX I_PROTROLETXT ON PROTROLETXT(APPSYSTNAME,ROLEID,LANGUE);

2,CREATE TABLE PROTROLEFUNC (
    APPSYSTNAME     varchar (16)  NOT NULL,
    ROLEID          varchar (16)  NOT NULL,
    FUNCID          varchar (16)  NOT NULL);
2,CREATE  UNIQUE INDEX I_PROTROLEFUNC ON PROTROLEFUNC(APPSYSTNAME,ROLEID,FUNCID);

2,ALTER TABLE PROTASSIGN ADD            ASSIGNENTRYTYPE smallint        NULL;
2,ALTER TABLE PROTUSR    ADD            EMAIL           varchar (240)   NULL;
2,ALTER TABLE APPBLOB    ALTER COLUMN   BLOBDESC        text;
2,ALTER TABLE PROTASSIGN ALTER COLUMN   USERCONTEXT     varchar (255) NOT NULL;

2,drop index USRDEFATTR.I_USRDEFATTR;
2,CREATE UNIQUE INDEX I_USRDEFATTR ON USRDEFATTR(ATTRLSTNAME,ATTRNAME,ATTRCAT);
2,ALTER TABLE USRDEFATTR ALTER COLUMN ATTRPROMPT varchar (80)  NULL;
2,ALTER TABLE USRDEFATTR ALTER COLUMN ANSDEFAULT varchar (240) NULL;
2,ALTER TABLE USRDEFATTR ALTER COLUMN ANSCHOICE	 varchar (240) NULL;
2,ALTER TABLE USRDEFATTR DROP COLUMN ATTRHELP;
2,ALTER TABLE USRDEFATTR ADD ATTRHELP	 text          NULL;