0,DROP TABLE DEMO_ADDRESS_HIST;
0,DROP TABLE DEMO_CLIENT_HIST;
0,DROP TABLE DEMO_PHONE_HIST;
2,CREATE TABLE DEMO_CLIENT_HIST(
        CLIENTCODE          char(16)                NOT NULL,
        LOGDATE             datetime                NOT NULL,
        CLIENTFIRSTNAME     varchar(40)             NULL,
        CLIENTLASTNAME      char(40)                NOT NULL,
        CLIENTTYPE          int                     NOT NULL,
        CIECODE             char(16)                NULL,
        CLIENTSALESTODATE   decimal(18,2)           NOT NULL,
        CREATIONDATE        datetime                NOT NULL,
        MODIFICATIONDATE    datetime                NOT NULL,
        DESCRIPTION         text                    NULL,
        LOGREASON           char(3)                 NULL,
        LOGUSER             char(40)                NULL,
    PRIMARY KEY (CLIENTCODE, LOGDATE));
2,CREATE UNIQUE INDEX I_DEMO_CLIENT_HIST ON DEMO_CLIENT_HIST(CLIENTCODE,LOGDATE);
2,CREATE TABLE DEMO_ADDRESS_HIST(
        CLIENTCODE          char(16)                NOT NULL, 
        ADDRESSCODE         int                     NOT NULL,
        LOGDATE             datetime                NOT NULL,
        ADDRESS_LINE1       varchar(80)             NOT NULL,
        ADDRESS_LINE2       varchar(80)             NULL,
        CITY                varchar(40)             NOT NULL,
        POSTALCODE          varchar(6)              NOT NULL,
        PROVINCE            varchar(2)              NULL, 
        LOGREASON           char(3)                 NULL,
        LOGUSER             char(40)                NULL,
    PRIMARY KEY (CLIENTCODE, ADDRESSCODE, LOGDATE));
2,CREATE UNIQUE INDEX I_DEMO_ADDRESS_HIST ON DEMO_ADDRESS_HIST(CLIENTCODE, ADDRESSCODE,LOGDATE);
2,CREATE TABLE DEMO_PHONE_HIST(
        CLIENTCODE          char(16)                NOT NULL,
        ADDRESSCODE         int                     NOT NULL,
        PHONECODE           int                     NOT NULL,
        LOGDATE             datetime                NOT NULL,
        PHONETYPE           int                     NOT NULL,
        PHONENUMBER         varchar(15)             NOT NULL,
        LOGREASON           char(3)                 NULL,
        LOGUSER             char(40)                NULL,
    PRIMARY KEY (CLIENTCODE, ADDRESSCODE, PHONECODE, LOGDATE));
2,CREATE UNIQUE INDEX I_DEMO_PHONE_HIST ON DEMO_PHONE_HIST(CLIENTCODE, ADDRESSCODE, PHONECODE,LOGDATE);
